<?php

declare(strict_types=1);

namespace Dedi\SyliusSogenactifPlugin\Payum\Sogenactif;

use Dedi\SyliusSogenactifPlugin\Payum\Sogenactif\Action\Status;
use Dedi\SyliusSogenactifPlugin\Payum\Sogenactif\Api as SogenactifApi;
use Payum\Core\Bridge\Spl\ArrayObject;
use Payum\Core\GatewayFactory;

final class PaymentGatewayFactory extends GatewayFactory
{
    protected function populateConfig(ArrayObject $config): void
    {
        $config->defaults([
            'payum.factory_name' => 'app_sogenactif_checkout',
            'payum.factory_title' => 'Paiement via Sogenactif',
            'payum.action.status' => new Status(),
        ]);

        $config['payum.api'] = function (ArrayObject $config) {
            return new SogenactifApi(
                $config['secret_key'],
                $config['merchant_id'],
                $config['key_version']
            );
        };
    }
}
